︠140180b8-69f3-4767-ad27-056b7bce5d31s︠
def l_matrix(n,i,t):
    return elementary_matrix(n, row1=i-1, row2=i, scale=t)

def bruhat_to_catalan(n):
    for w in Permutations(n):
        print(w)
        M = identity_matrix(n)
        a = w.reduced_word()
        R = PolynomialRing(QQ, 'x', len(a))
        for i in range(len(a)):
            M = l_matrix(n,a[i],R.gens()[i])*M
        print(M)
        print()
︡3f5fce6c-3f59-4492-8475-819c1cac5415︡{"done":true}
︠4f286316-d118-4d48-8ad8-3ff11e269fa8s︠
bruhat_to_catalan(3)
︡1d5c685d-6bf5-45cd-a209-35d366e51e36︡{"stdout":"[1, 2, 3]\n[1 0 0]\n[0 1 0]\n[0 0 1]\n\n[1, 3, 2]\n[1 0 0]\n[0 1 x]\n[0 0 1]\n\n[2, 1, 3]\n[1 x 0]\n[0 1 0]\n[0 0 1]\n\n[2, 3, 1]\n[ 1 x0  0]\n[ 0  1 x1]\n[ 0  0  1]\n\n[3, 1, 2]\n[    1    x1 x0*x1]\n[    0     1    x0]\n[    0     0     1]\n\n[3, 2, 1]\n[      1      x1   x0*x1]\n[      0       1 x0 + x2]\n[      0       0       1]\n\n"}︡{"done":true}
︠da6e2479-e156-4e6a-8580-1987da950295s︠
bruhat_to_catalan(4)
︡e91befab-deb0-4531-b1c2-fa1c29025c74︡{"stdout":"[1, 2, 3, 4]\n[1 0 0 0]\n[0 1 0 0]\n[0 0 1 0]\n[0 0 0 1]\n\n[1, 2, 4, 3]\n[1 0 0 0]\n[0 1 0 0]\n[0 0 1 x]\n[0 0 0 1]\n\n[1, 3, 2, 4]\n[1 0 0 0]\n[0 1 x 0]\n[0 0 1 0]\n[0 0 0 1]\n\n[1, 3, 4, 2]\n[ 1  0  0  0]\n[ 0  1 x0  0]\n[ 0  0  1 x1]\n[ 0  0  0  1]\n\n[1, 4, 2, 3]\n[    1     0     0     0]\n[    0     1    x1 x0*x1]\n[    0     0     1    x0]\n[    0     0     0     1]\n\n[1, 4, 3, 2]\n[      1       0       0       0]\n[      0       1      x1   x0*x1]\n[      0       0       1 x0 + x2]\n[      0       0       0       1]\n\n[2, 1, 3, 4]\n[1 x 0 0]\n[0 1 0 0]\n[0 0 1 0]\n[0 0 0 1]\n\n[2, 1, 4, 3]\n[ 1 x0  0  0]\n[ 0  1  0  0]\n[ 0  0  1 x1]\n[ 0  0  0  1]\n\n[2, 3, 1, 4]\n[ 1 x0  0  0]\n[ 0  1 x1  0]\n[ 0  0  1  0]\n[ 0  0  0  1]\n\n[2, 3, 4, 1]\n[ 1 x0  0  0]\n[ 0  1 x1  0]\n[ 0  0  1 x2]\n[ 0  0  0  1]\n\n[2, 4, 1, 3]\n[    1    x0     0     0]\n[    0     1    x2 x1*x2]\n[    0     0     1    x1]\n[    0     0     0     1]\n\n[2, 4, 3, 1]\n[      1      x0       0       0]\n[      0       1      x2   x1*x2]\n[      0       0       1 x1 + x3]\n[      0       0       0       1]\n\n[3, 1, 2, 4]\n[    1    x1 x0*x1     0]\n[    0     1    x0     0]\n[    0     0     1     0]\n[    0     0     0     1]\n\n[3, 1, 4, 2]\n[    1    x1 x0*x1     0]\n[    0     1    x0     0]\n[    0     0     1    x2]\n[    0     0     0     1]\n\n[3, 2, 1, 4]\n[      1      x1   x0*x1       0]\n[      0       1 x0 + x2       0]\n[      0       0       1       0]\n[      0       0       0       1]\n\n[3, 2, 4, 1]\n[      1      x1   x0*x1       0]\n[      0       1 x0 + x2       0]\n[      0       0       1      x3]\n[      0       0       0       1]\n\n[3, 4, 1, 2]\n[      1      x1   x0*x1       0]\n[      0       1 x0 + x3   x2*x3]\n[      0       0       1      x2]\n[      0       0       0       1]\n\n[3, 4, 2, 1]\n[      1      x1   x0*x1       0]\n[      0       1 x0 + x3   x2*x3]\n[      0       0       1 x2 + x4]\n[      0       0       0       1]\n\n[4, 1, 2, 3]\n[       1       x2    x1*x2 x0*x1*x2]\n[       0        1       x1    x0*x1]\n[       0        0        1       x0]\n[       0        0        0        1]\n\n[4, 1, 3, 2]\n[       1       x2    x1*x2 x0*x1*x2]\n[       0        1       x1    x0*x1]\n[       0        0        1  x0 + x3]\n[       0        0        0        1]\n\n[4, 2, 1, 3]\n[            1            x2         x1*x2      x0*x1*x2]\n[            0             1       x1 + x3 x0*x1 + x0*x3]\n[            0             0             1            x0]\n[            0             0             0             1]\n\n[4, 2, 3, 1]\n[            1            x2         x1*x2      x0*x1*x2]\n[            0             1       x1 + x3 x0*x1 + x0*x3]\n[            0             0             1       x0 + x4]\n[            0             0             0             1]\n\n[4, 3, 1, 2]\n[                    1                    x2                 x1*x2              x0*x1*x2]\n[                    0                     1               x1 + x4 x0*x1 + x0*x4 + x3*x4]\n[                    0                     0                     1               x0 + x3]\n[                    0                     0                     0                     1]\n\n[4, 3, 2, 1]\n[                    1                    x2                 x1*x2              x0*x1*x2]\n[                    0                     1               x1 + x4 x0*x1 + x0*x4 + x3*x4]\n[                    0                     0                     1          x0 + x3 + x5]\n[                    0                     0                     0                     1]\n\n"}︡{"done":true}









